package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ConstantPushInstruction;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.Visitor;

public class FCONST extends Instruction implements ConstantPushInstruction {
  private float value;
  
  FCONST() {}
  
  public FCONST(float f) {
    super((short)11, (short)1);
    if (f == 0.0D) {
      setOpcode((short)11);
    } else if (f == 1.0D) {
      setOpcode((short)12);
    } else if (f == 2.0D) {
      setOpcode((short)13);
    } else {
      throw new ClassGenException("FCONST can be used only for 0.0, 1.0 and 2.0: " + f);
    } 
    this.value = f;
  }
  
  public void accept(Visitor v) {
    v.visitPushInstruction(this);
    v.visitStackProducer(this);
    v.visitTypedInstruction(this);
    v.visitConstantPushInstruction(this);
    v.visitFCONST(this);
  }
  
  public Type getType(ConstantPoolGen cp) {
    return Type.FLOAT;
  }
  
  public Number getValue() {
    return Float.valueOf(this.value);
  }
}
